/*
 * AddEditWorld.java
 *
 * Created on April 9, 2006, 4:57 PM
 */

package anecho.JamochaMUD;

import anecho.gui.EasyTreeIconRenderer;
import java.beans.XMLDecoder;
import java.beans.XMLEncoder;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Vector;
import javax.swing.JOptionPane;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import javax.swing.tree.TreePath;

/**
 * AddEditWorld is a class that displays saved worlds and characters
 * in a tree format.  It allows for editing of this information and
 * connection to the different worlds.  This class is a replacement
 * for the older MuckConn class.
 * $Id: AddEditWorld.java,v 1.17 2006/11/17 06:23:40 jeffnik Exp $
 * @author J. Robinson
 */
public class AddEditWorld extends javax.swing.JDialog {
    
    /** Creates new form AddEditWorld */
    public AddEditWorld() {
        super(JMConfig.getInstance().getJMFrame(JMConfig.MUCKMAINFRAME), true);
        
        initComponents();
        
        java.awt.Point tPoint = anecho.gui.PosTools.findCenter();
        java.awt.Dimension tSize = this.size();
        this.setLocation(tPoint.x - (int)(tSize.width/2) , tPoint.y - (int)(tSize.height/2));
        
        readWorlds();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        worldTreePanel = new javax.swing.JPanel();
        worldScrollPane = new javax.swing.JScrollPane();
        // optionRoot = new DefaultMutableTreeNode("Worlds");
        worldTreeModel = new DefaultTreeModel(optionRoot);

        worldTree = new javax.swing.JTree(optionRoot);
        buildTree();
        // EasyTreeIconRenderer renderer = (EasyTreeIconRenderer)worldTree.getCellRenderer();
        EasyTreeIconRenderer renderer = new EasyTreeIconRenderer();
        worldTree.setCellRenderer(renderer);
        //renderer.addIcon("Test",new ImageIcon(AddEditWorld.class.getResource("icons/22/import.png")));
        //DefaultTreeCellRenderer renderer = (DefaultTreeCellRenderer)worldTree.getCellRenderer();
        //UIManager.put("Tree.leafIcon", new ImageIcon(AddEditWorld.class.getResource("icons/22/import.png")));
        //UIManager.put("Tree.openIcon", new ImageIcon(AddEditWorld.class.getResource("icons/22/import.png")));
        //UIManager.put("Tree.closedIcon", new ImageIcon(AddEditWorld.class.getResource("icons/22/import.png")));

        addB = new javax.swing.JButton();
        delB = new javax.swing.JButton();
        buttonPanel = new javax.swing.JPanel();
        connB = new javax.swing.JButton();
        saveConnB = new javax.swing.JButton();
        saveB = new javax.swing.JButton();
        cancelB = new javax.swing.JButton();
        infoPanel = new javax.swing.JPanel();
        worldPanel = new javax.swing.JPanel();
        worldInfoPanel = new javax.swing.JPanel();
        sslCB = new javax.swing.JCheckBox();
        mPortTF = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        mAddressTF = new javax.swing.JTextField();
        mNameTF = new javax.swing.JTextField();
        worldNotesPane = new javax.swing.JScrollPane();
        muNotesTA = new javax.swing.JTextArea();
        charPanel = new javax.swing.JPanel();
        charNotesL = new javax.swing.JLabel();
        charNotes = new javax.swing.JScrollPane();
        characterNotes = new javax.swing.JTextArea();
        charInfoPanel = new javax.swing.JPanel();
        nameL = new javax.swing.JLabel();
        charName = new javax.swing.JTextField();
        passwordL = new javax.swing.JLabel();
        charAutoLogin = new javax.swing.JCheckBox();
        connTypeCB = new anecho.gui.JMappedComboBox();
        charPassword = new javax.swing.JPasswordField();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("JamochaMUD MU* Connector");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        worldTreePanel.setLayout(new java.awt.GridBagLayout());

        worldTree.setToolTipText("A list of your current MU*s.  The ability to add character is not complete at this time.");
        worldTree.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                worldTreeMouseClicked(evt);
            }
        });

        worldScrollPane.setViewportView(worldTree);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weighty = 0.9;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        worldTreePanel.add(worldScrollPane, gridBagConstraints);

        addB.setText("Add");
        addB.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                addBMouseClicked(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.weighty = 0.1;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        worldTreePanel.add(addB, gridBagConstraints);

        delB.setText("Delete");
        delB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                delBActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.weighty = 0.1;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        worldTreePanel.add(delB, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(7, 7, 3, 3);
        getContentPane().add(worldTreePanel, gridBagConstraints);

        buttonPanel.setLayout(new java.awt.GridBagLayout());

        connB.setText("Connect Only");
        connB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                connBActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
        buttonPanel.add(connB, gridBagConstraints);

        saveConnB.setText("Save & Connect");
        saveConnB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveConnBActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
        buttonPanel.add(saveConnB, gridBagConstraints);

        saveB.setText("Save");
        saveB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveBActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
        buttonPanel.add(saveB, gridBagConstraints);

        cancelB.setText("Don't connect");
        cancelB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelBActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(0, 2, 0, 2);
        buttonPanel.add(cancelB, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 7, 7, 7);
        getContentPane().add(buttonPanel, gridBagConstraints);

        infoPanel.setLayout(new java.awt.CardLayout());

        worldPanel.setLayout(new java.awt.GridBagLayout());

        worldPanel.setName("WorldCardPanel");
        worldInfoPanel.setLayout(new java.awt.GridBagLayout());

        worldInfoPanel.setName("card2");
        sslCB.setText("Secure Connection (SSL)");
        sslCB.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        sslCB.setMargin(new java.awt.Insets(0, 0, 0, 0));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 7, 3);
        worldInfoPanel.add(sslCB, gridBagConstraints);

        mPortTF.setColumns(20);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        worldInfoPanel.add(mPortTF, gridBagConstraints);

        jLabel3.setText("MU* Port");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 0);
        worldInfoPanel.add(jLabel3, gridBagConstraints);

        jLabel2.setText("MU* Address");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 0);
        worldInfoPanel.add(jLabel2, gridBagConstraints);

        jLabel4.setText("Notes");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.gridheight = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(7, 3, 7, 3);
        worldInfoPanel.add(jLabel4, gridBagConstraints);

        jLabel1.setText("MU* Name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 0);
        worldInfoPanel.add(jLabel1, gridBagConstraints);

        mAddressTF.setColumns(20);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 3, 3, 3);
        worldInfoPanel.add(mAddressTF, gridBagConstraints);

        mNameTF.setColumns(20);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        worldInfoPanel.add(mNameTF, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 3, 3);
        worldPanel.add(worldInfoPanel, gridBagConstraints);

        muNotesTA.setColumns(30);
        muNotesTA.setRows(5);
        worldNotesPane.setViewportView(muNotesTA);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.gridheight = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(0, 3, 3, 3);
        worldPanel.add(worldNotesPane, gridBagConstraints);

        infoPanel.add(worldPanel, "card2");

        charPanel.setLayout(new java.awt.GridBagLayout());

        charPanel.setName("CharacterCardPanel");
        charNotesL.setText("Notes");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        charPanel.add(charNotesL, gridBagConstraints);

        characterNotes.setColumns(20);
        characterNotes.setRows(5);
        charNotes.setViewportView(characterNotes);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        charPanel.add(charNotes, gridBagConstraints);

        charInfoPanel.setLayout(new java.awt.GridBagLayout());

        nameL.setText("Character name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 3, 0, 3);
        charInfoPanel.add(nameL, gridBagConstraints);

        charName.setColumns(15);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 3, 3, 3);
        charInfoPanel.add(charName, gridBagConstraints);

        passwordL.setText("Password");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 0, 3);
        charInfoPanel.add(passwordL, gridBagConstraints);

        charAutoLogin.setText("Auto-login");
        charAutoLogin.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        charAutoLogin.setMargin(new java.awt.Insets(0, 0, 0, 0));
        charAutoLogin.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                charAutoLoginStateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 0, 3);
        charInfoPanel.add(charAutoLogin, gridBagConstraints);

        connTypeCB.setEditable(true);
        connTypeCB.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "connect $n $p" }));
        connTypeCB.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 0, 0, 3);
        charInfoPanel.add(connTypeCB, gridBagConstraints);

        charPassword.setText("jPasswordField1");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 0, 3);
        charInfoPanel.add(charPassword, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        charPanel.add(charInfoPanel, gridBagConstraints);

        infoPanel.add(charPanel, "card3");

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weighty = 0.8;
        gridBagConstraints.insets = new java.awt.Insets(7, 3, 3, 7);
        getContentPane().add(infoPanel, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void charAutoLoginStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_charAutoLoginStateChanged
        connTypeCB.setEnabled(charAutoLogin.isSelected());
    }//GEN-LAST:event_charAutoLoginStateChanged
    
    private void saveConnBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveConnBActionPerformed
        saveInfo();
        connectToMU();
    }//GEN-LAST:event_saveConnBActionPerformed
    
    private void delBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_delBActionPerformed
        deleteTreeItem();
    }//GEN-LAST:event_delBActionPerformed
    
    private void connBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_connBActionPerformed
        connectToMU();
    }//GEN-LAST:event_connBActionPerformed
    
    private void saveBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveBActionPerformed
        saveInfo();
    }//GEN-LAST:event_saveBActionPerformed
    
    private void addBMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_addBMouseClicked
        addTreeItem(evt);
    }//GEN-LAST:event_addBMouseClicked
    
    private void worldTreeMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_worldTreeMouseClicked
        updateInfo();
        
        // If we have a double-click, connect to the given MU*
        if (evt.getClickCount() > 1) {
            connectToMU();
        }
        
    }//GEN-LAST:event_worldTreeMouseClicked
    
    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        // If there are no worlds open already, we should terminate JamochaMUD
        final JMConfig settings = JMConfig.getInstance();
        final CHandler chandle = settings.getConnectionHandler();
        
        if (chandle.totalConnections() < 1) {
            if (DEBUG) {
                System.err.println("AddEditWorld.formWindowClosed is terminating JamochaMUD.");
            }
            System.exit(0);
        }
        
        dontConnect();
    }//GEN-LAST:event_formWindowClosed
    
    private void cancelBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelBActionPerformed
        dontConnect();
    }//GEN-LAST:event_cancelBActionPerformed
        
    /** Connect to the currently selected world */
    private void connectToMU() {
        // Get the selected node
        World tempWorld;
        MUChar tempChar = new MUChar();
        
        final Object tempNode = worldTree.getLastSelectedPathComponent();
        
        // Determine if the node is a world or character
        try {
            tempWorld = (World)tempNode;
            tempChar.setName(null); // Set the name to null so we don't try to use a character
            
            if (DEBUG) {
                System.err.println("Attempting connection to world: " + tempWorld.getWorldName());
            }
        } catch (Exception castExc) {
            tempChar = (MUChar)tempNode;
            if (DEBUG) {
                System.err.println("Will make connection to world using character " + tempChar.getName());
            }
            
            // Now determine the world this character belongs to
            try {
                tempWorld = (World)tempChar.getParent();
                
                if (DEBUG) {
                    System.err.println(tempChar.getName() + " connecting to " + tempWorld.getAddress());
                }
                
            } catch (Exception worldExc) {
                if (DEBUG) {
                    System.err.println("Error trying to locate parent of " + tempChar.getName());
                    System.err.println("Error: " + worldExc);
                }
                
                // Create a new world to placate the initialisation errors
                tempWorld = new World();
            }
            
        }
        
        currentWorld = tempWorld;
        currentChar = tempChar;
        
        if (DEBUG) {
            System.err.println("Setting currentWorld to: " + currentWorld.getWorldName());
            System.err.println("Setting currentChar to: " + currentChar.getName());
        }
        
        hideConnector();
    }
    
    /** Add either a new world or new character to our JTree */
    private void addTreeItem(java.awt.event.MouseEvent evt) {
        
        // Determine if there is anything selected right now.
        // If nothing is selected, default to the root which means adding a world
        final TreePath currentSelection = worldTree.getSelectionPath();
        final TreePath[] testSelection = worldTree.getSelectionPaths();
        
        // This is suspect... it may only function properly if the tree has not
        // had any nodes selected.  Fix Me XXX
        if (DEBUG) {
            if (currentSelection != null) {
                System.err.println("Current selection: " + testSelection);
            }
            System.err.println("Root: " + optionRoot.getPath());
            
        }
        if (currentSelection == null) {
            if (DEBUG) {
                System.err.println("AddEditWorld.addTreeItem current has no selected node.");
                System.err.println("We should add a world by default");
            }
            
            addWorldItem();
        } else {
            // I don't like this try block, but it will have to work for now.
            try {
                addCharacterItem(currentSelection);
            } catch (Exception charExc) {
                addWorldItem();
            }
        }
        
    }
    
    /** Add a world item to our Tree */
    private void addWorldItem() {
        final World tempWorld = new World();
        
        tempWorld.setWorldName("Nothing");
        tempWorld.setAddress("No address");
        tempWorld.setPort(0);
        final int len = optionRoot.getChildCount();
        final int treeCount = worldTree.getRowCount();
        
        if (DEBUG) {
            System.err.println("AddEditWorld.addWorldItem: optionRoot reports we have " + len + " children on our tree.");
            System.err.println("AddEditWorld.addWorldItem: worldTree reports we have " + treeCount + "rows.");
            System.err.println("AddEditWorld.addWorldItem: our worldTreeModel reports we have " + worldTreeModel.getChildCount(optionRoot) + " children");
            System.err.println("AddEditWorld.addWorldItem: Dynamically collected root node says we have " + ((DefaultMutableTreeNode)worldTreeModel.getRoot()).getChildCount());
        }
        
        worldTreeModel.insertNodeInto(tempWorld, optionRoot, len);
        worldTree.updateUI();
        
        if (DEBUG) {
            System.err.println("After insertion we have " + optionRoot.getChildCount() + " children.");
        }
        
        // Select the newly created world, and then move focus to our editing area
        final TreePath treePath = new TreePath(worldTreeModel.getPathToRoot(tempWorld));
        worldTree.setSelectionPath(treePath);
        updateInfo();
        
        mNameTF.requestFocusInWindow();
    }
    
    /** Add a new character item to our Tree */
    private void addCharacterItem(final TreePath currentSelection) {
        if (DEBUG) {
            System.err.println("AddEditWorld.addCharacterItem()");
        }
        
        // Get the World node that is currently selected
        final World tempWorld = (World)(currentSelection.getLastPathComponent());
        
        // Create the new character
        final MUChar tempChar = new MUChar();
        tempChar.setName("Nobody yet");
        // Assign the proper worldID to the character
        tempChar.setWorldID(tempWorld.getWorldID());
        
        
        // Insert the new character into our JTree
        worldTreeModel.insertNodeInto(tempChar, tempWorld, 0);
        worldTree.updateUI();
        
        // Focus on the new character
        final TreePath treePath = new TreePath(worldTreeModel.getPathToRoot(tempChar));
        worldTree.setSelectionPath(treePath);
        updateInfo();

        charName.requestFocusInWindow();
    }
    
    /** Delete the currently selected item from the Tree */
    private void deleteTreeItem() {
        final TreePath currentSelection = worldTree.getSelectionPath();
        
        if (currentSelection == null) {
            // There is currently no selected node on the JTree
            return;
        }
        
        if (currentSelection != null) {
            final DefaultMutableTreeNode currentNode = (DefaultMutableTreeNode)
            (currentSelection.getLastPathComponent());
            final MutableTreeNode parent = (MutableTreeNode)(currentNode.getParent());
            if (parent == null) {
                if (DEBUG) {
                    System.err.println("AddEditWorld.deleteTreeItem() has no parent");
                }
            } else {
                if (DEBUG) {
                    System.err.println("AddEditWorld.deleteTreeItem() Removing node.");
                }
                worldTreeModel.removeNodeFromParent(currentNode);
            }
        } else {
            if (DEBUG) {
                System.err.println("AddEditWorld.deleteTreeItem() has no current selection.");
            }
        }
        
        worldTree.updateUI();
        
        // Select next applicable node
        updateInfo();
        
        
    }
    
    private void dontConnect() {
        currentWorld.setWorldName(null);
        
        hideConnector();
        
    }
    
    private void hideConnector() {
        setVisible(false);
        final JMConfig settings = JMConfig.getInstance();
        
        final java.awt.Frame mmFrame = settings.getJMFrame(JMConfig.MUCKMAINFRAME);
        if (!mmFrame.isVisible()) {
            mmFrame.setVisible(true);
        }
        
        settings.setJMValue(JMConfig.MUCKCONNVISIBLE, false);
        
        // Send the focus to our main program... just a nice thing to do
        mmFrame.requestFocus();
        
        writeWorlds();
        // writeCharacters();
    }
    
    /** Read the worlds in from permanent storage.
     */
    private void readWorlds() {
        // Read in the worlds XML file
        final JMConfig settings = JMConfig.getInstance();
        boolean worldsExist = false;
        
        try {
            final FileInputStream fInStream = new FileInputStream(settings.getJMString(JMConfig.USERDIRECTORY) + TREEFILE);
            final BufferedInputStream bufInStream = new BufferedInputStream(fInStream);
            
            final XMLDecoder decoder = new XMLDecoder(bufInStream);
            worldTreeModel = (DefaultTreeModel)decoder.readObject();
            decoder.close();
            
            bufInStream.close();
            fInStream.close();
            
            // worldTreeModel.setRoot(optionRoot);
            
            worldTree.setModel(worldTreeModel);
            worldTree.updateUI();
        
            // Make certain to set optionRoot to our new root, or we'll have a big disconnect
            // between the model and the actual viewable tree
            optionRoot = (DefaultMutableTreeNode)worldTreeModel.getRoot();
            
            worldsExist = true;
        } catch (Exception treeExc) {
            if (DEBUG) {
                System.err.println("AddEditWorld error reading in XML worlds file.  Try importing old worlds?");
            }
        }
        
        // Try to read our list of worlds
        
        if (DEBUG) {
            System.err.println("AddEditWorld.readWorlds: Our optionRoot has " + optionRoot.getChildCount() + " children.");
        }
        
        if (!worldsExist) {
            // We have no worlds, and can therefore not have any characters
            if (DEBUG) {
                System.err.println("AddEditWorld.readWorlds: No worlds to read.");
            }
            
            // If we have no worlds, try to import old worlds instead
            importOldWorlds();
            
            return;
        }
        
        // Update the tree view to show all our info
        worldTree.expandRow(0);
        worldTree.updateUI();
        
        final int treeCount = worldTree.getRowCount();
        
        if (DEBUG) {
            System.err.println("AddEditWorld.readWorlds: worldTree.getRowCount returns " + treeCount + " rows.");
        }
        
        for (int i = 0; i < treeCount; i++) {
            worldTree.expandRow(i);
        }
        
        
    }
    
    private void writeWorlds() {
        // New method for saving JTree information to avoid serializing problems
        final JMConfig settings = JMConfig.getInstance();
        
        if (DEBUG) {
            System.err.println("AddEditWorld.writeWorlds(): writing out JTree to XML file.");
        }
        try {
            final XMLEncoder encoder = new XMLEncoder( new BufferedOutputStream(
                    new FileOutputStream(settings.getJMString(JMConfig.USERDIRECTORY) + TREEFILE)));
            
            encoder.writeObject(worldTreeModel);
            encoder.close();
        } catch (Exception exc) {
            System.err.println("AddEditWorld error trying to saving JTree to file.");
        }
        
        if (DEBUG) {
            System.err.println("AddEditWorld.writeWorlds(): complete.");
        }
    }
    
    /** Add all the nodes to our JTree of options */
    private void buildTree() {
    }
    
    /** Enables or disables our auto-login style */
//    private void enableLoginStyle(final boolean state) {
////        loginL.setEnabled(state);
////        loginStyleCB.setEnabled(state);
//    }
    
    /**
     * Return the name of the currently selected world
     * @return Returns a string of containing the currently selected
     * World's name.
     */
    public String getName() {
        String retStr = "nothing";
        
        if (currentWorld != null) {
            retStr = currentWorld.getWorldName();
        }
        
        return retStr;
    }
    
    /**
     * Return the address of the currently selected World.
     * @return The address of the currently selected World.
     */
    public String getAddress() {
        String retStr = "nothing";
        
        if (currentWorld != null) {
            retStr = currentWorld.getAddress();
        }
        return retStr;
    }
    
    /**
     * Returns the port number of the currently selected World.
     * @return Returns the port number of the currently selected World.
     */
    public int getPort() {
        int retPort = -1;
        if (currentWorld != null) {
            retPort = currentWorld.getPort();
        }
        return retPort;
    }
    
    /**
     * Returns whether the currently selected world uses a secure (SSL)
     * connection.
     * @return <CODE>true</CODE> - this world uses a secure (SSL) connection
     * <CODE>false</CODE> - this world sends data unencrypted
     */
    public boolean getSSL() {
        boolean retSSL = false;
        if (currentWorld != null) {
            retSSL = currentWorld.getSSL();
        }
        return retSSL;
    }
    
    /**
     * Return a complete connection string with the username and password inserted
     * @return Returns a string made up of the character's connection
     * string.  Any $n (username) or $p (password) variables
     * are also substituted for the actual entries and
     * made part of the return string.
     */
    public String getConnectionString() {
        String connString = "";
        
        if (charAutoLogin.isSelected()) {
            connString = connTypeCB.getSelectedItem().toString();
            
            final String charName = currentChar.getName();
            final String charPass = currentChar.getPassword().toString();
            
            connString = connString.replaceAll("\\$n", charName);
            connString = connString.replaceAll("\\$p", charPass);
            
            if (DEBUG) {
                System.err.println("AddEditWorlds.getConnectionString() returns a connection string of: " + connString);
            }
        }
        
        return connString;
    }
    
    private void updateInfo() {
        // Update the shown info based on the item selected in the World JTree
        
        // Get the selected node
        final Object tempNode = worldTree.getLastSelectedPathComponent();
        final int selCount = worldTree.getSelectionCount();
        
        if (DEBUG) {
            System.err.println("AddEditWorld.updateInfo(): Selection count is: " + selCount);
        }
        // Determine if the node is a world or character
        try {
            final World tempWorld = (World)tempNode;
            if (DEBUG) {
                System.err.println("We have cast this to World: " + tempWorld.getWorldName());
            }
            updateWorldForm(tempWorld);
        } catch (Exception castExc) {
            if (DEBUG) {
                System.err.println("Error casting " + tempNode + " to a world.");
            }
            
            // Most likely this is a character
            try {
                final MUChar tempChar = (MUChar)tempNode;
                if (DEBUG) {
                    System.err.println("AddEditWorld.updateInfo() have cast this to a Character:" + tempChar.getName());
                }
                updateCharacterForm(tempChar);
            } catch (Exception charExc) {
                if (DEBUG) {
                    System.err.println("AddEditWorld.updateInof() cast has failed for both a world and a character");
                }
            }
            
        }
        
    }
    
    private void updateWorldForm(final World selWorld) {
        // Ensure that the correct panel is showing
        final java.awt.CardLayout tempLayout = (java.awt.CardLayout)infoPanel.getLayout();
        tempLayout.show(infoPanel, "card2");
        if (DEBUG) {
            System.err.println("AddEditWorld.updateWorldForm() should be showing world panel");
        }
        
        // fill the form
        mNameTF.setText(selWorld.getWorldName());
        mAddressTF.setText(selWorld.getAddress());
        mPortTF.setText(selWorld.getPort() + "");
        sslCB.setSelected(selWorld.getSSL());
        // autoLoginCB.setSelected(selWorld.isAutoLogin());
        // loginStyleCB.setSelectedIndex(selWorld.getLoginStyle());
        muNotesTA.setText(selWorld.getNotes());
    }
    
    private void updateCharacterForm(final MUChar selChar) {
        // Ensure the panel is showing
        final java.awt.CardLayout tempLayout = (java.awt.CardLayout)infoPanel.getLayout();
        // tempLayout.show(infoPanel, "CharacterCardPanel");
        tempLayout.show(infoPanel, "card3");
        
        if (DEBUG) {
            System.err.println("AddEditWorld.updateCharacterForm() should be showing character panel");
        }
        
        // fill the form
        charName.setText(selChar.getName());
        charPassword.setText(selChar.getPassword());
        // charConnString.setText(selChar.getConnString());
        characterNotes.setText(selChar.getNotes());
        charAutoLogin.setSelected(selChar.getAutoLogin());
        connTypeCB.setSelectedItem(selChar.getLoginStyle());
    }
    
    /** Save the current information in our form to our selected node */
    private void saveInfo() {
        // Get the selected node
        final Object tempNode = worldTree.getLastSelectedPathComponent();
        
        // Determine if the node is a world or character
        try {
            final World tempWorld = (World)tempNode;
            if (DEBUG) {
                System.err.println("saveInfo has cast this to World: " + tempWorld.getWorldName());
            }
            saveWorldInfo(tempWorld);
        } catch (Exception castExc) {
            if (DEBUG) {
                System.err.println("saveInfo Error casting " + tempNode + " to a world.");
            }
            
            try {
                final MUChar tempChar = (MUChar)tempNode;
                if (DEBUG) {
                    System.err.println("AddEditWorld.saveInfo has cast this node to Char: " + tempChar.getName());
                }
                saveCharacterInfo(tempChar);
            } catch (Exception charExc) {
                if (DEBUG) {
                    System.err.println("AddEditWorld.saveInfo cannot cast " + tempNode + " to either a world or character.");
                }
            }
        }
        
    }
    
    /** Update the world object in our JTree with the information from the TextFields */
    private void saveWorldInfo(final World selWorld) {
        selWorld.setWorldName(mNameTF.getText());
        selWorld.setAddress(mAddressTF.getText());
        selWorld.setPort(Integer.parseInt(mPortTF.getText()));
        selWorld.setSSL(sslCB.isSelected());
        // selWorld.useAutoLogin(autoLoginCB.isSelected());
        // selWorld.setLoginStyle(loginStyleCB.getSelectedIndex());
        selWorld.setNotes(muNotesTA.getText());
        
        // Update the JTree view
        worldTree.updateUI();
        
        if (DEBUG) {
            System.err.println("Saved world information");
        }
    }
    
    /** Write the information from our character form into our tree node */
    private void saveCharacterInfo(final MUChar selChar) {
        
        // We have to collect the password and write it out in plain text.
        // Not secure, but JamochaMUD isn't intended to Supah-secret stuff!
        final StringBuffer pWord = new StringBuffer();
        final char[] charWord = charPassword.getPassword();
        
        final int len = charWord.length;
        for (int i = 0; i < len; i++) {
            if (DEBUG) {
                System.err.println("Appending password: " + charWord[i]);
            }
            pWord.append(charWord[i]);
        }
        
        if (DEBUG) {
            System.err.println("Total password is " + pWord.toString());
        }
        
        selChar.setName(charName.getText());
        selChar.setNotes(characterNotes.getText());
        // selChar.setPassword(charPassword.getPassword().toString());
        selChar.setPassword(pWord.toString());
        // selChar.setConnString(charConnString.getText());
        selChar.setAutoLogin(charAutoLogin.isSelected());
        selChar.setLoginStyle((String)connTypeCB.getSelectedItem());
        
        // Update the JTree to show changes
        worldTree.updateUI();
    }
    
    /** Import worlds from the format previously used by JamochaMUD */
    private void importOldWorlds() {
        Vector muckList = new java.util.Vector(0, 1);
        final JMConfig settings = JMConfig.getInstance();
        muckList = settings.getJMVector(JMConfig.MUCKLIST);
        
        if (DEBUG) {
            System.err.println("AddEditWorld.importOldWorlds() attempting to import old-style MU settings");
        }
        
        World tempWorld;
        MuckInfo tempMU;
        
        final int listSize = muckList.size();
        
        // Check to see if there are worlds to import
        if (listSize > 0) {
            // There are worlds to possibly import.  We should ask the user first
            final int retVal = JOptionPane.showConfirmDialog(this,
                    "Would you like to import your existing worlds\ninto this version of JamochaMUD?",
                    "Import existing worlds?",
                    JOptionPane.YES_NO_OPTION);
            
            if (retVal == JOptionPane.NO_OPTION) {
                return;
            }
        } else {
            // Is this return necessary?  Fix Me XXX
            return;
        }
        
        for (int i = 0; i < listSize; i++) {
            tempMU = (MuckInfo)muckList.elementAt(i);
            // We must create a new world each time or risk messing up our JTree
            tempWorld = new World();
            
            tempWorld.setWorldName(tempMU.getName());
            tempWorld.setAddress(tempMU.getAddress());
            tempWorld.setPort(tempMU.getPort());
            tempWorld.setSSL(tempMU.getSSL());
            
            if (DEBUG) {
                System.err.println("AddEditWorld.importOldWorlds() importing MU*: " + tempMU.getName());
            }
            
            // Insert the new world into our JTree
            worldTreeModel.insertNodeInto(tempWorld, optionRoot, optionRoot.getChildCount());
            
            if (DEBUG) {
                System.err.println("AddEditWorld.importOldWorlds() import successful.");
                System.err.println("There are now " + optionRoot.getChildCount() + " nodes on optionRoot.");
            }
        }
        
        worldTree.setModel(worldTreeModel);
        worldTree.updateUI();
        
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addB;
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JButton cancelB;
    private javax.swing.JCheckBox charAutoLogin;
    private javax.swing.JPanel charInfoPanel;
    private javax.swing.JTextField charName;
    private javax.swing.JScrollPane charNotes;
    private javax.swing.JLabel charNotesL;
    private javax.swing.JPanel charPanel;
    private javax.swing.JPasswordField charPassword;
    private javax.swing.JTextArea characterNotes;
    private javax.swing.JButton connB;
    private anecho.gui.JMappedComboBox connTypeCB;
    private javax.swing.JButton delB;
    private javax.swing.JPanel infoPanel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JTextField mAddressTF;
    private javax.swing.JTextField mNameTF;
    private javax.swing.JTextField mPortTF;
    private javax.swing.JTextArea muNotesTA;
    private javax.swing.JLabel nameL;
    private javax.swing.JLabel passwordL;
    private javax.swing.JButton saveB;
    private javax.swing.JButton saveConnB;
    private javax.swing.JCheckBox sslCB;
    private javax.swing.JPanel worldInfoPanel;
    private javax.swing.JScrollPane worldNotesPane;
    private javax.swing.JPanel worldPanel;
    private javax.swing.JScrollPane worldScrollPane;
    private javax.swing.JTree worldTree;
    private javax.swing.JPanel worldTreePanel;
    // End of variables declaration//GEN-END:variables
    
    private static final boolean DEBUG = false;
    private static final String TREEFILE = "worlds.xml";
    
    private DefaultMutableTreeNode optionRoot = new DefaultMutableTreeNode("Worlds");
    private DefaultTreeModel worldTreeModel;
    /**
     * This class contains the world currently selected, which is returned
     * to JamochaMUD if the user chooses to connect.
     */
    World currentWorld = new World();
    /**
     * The character selected by the user when they choose to connect.
     */
    MUChar currentChar = new MUChar();
}
