/*
 * World.java
 *
 * Created on September 24, 2006, 7:26 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package anecho.JamochaMUD;

import anecho.gui.EasyIconTreeNode;
import javax.swing.Icon;
import javax.swing.ImageIcon;

/**
 * This class is used to store information about Worlds in
 * JamochaMUD.  It is a extends a node so that it can easily
 * be added and manipulated in a JTree.
 * @author Jeff Robinson (jeffnik@anecho.mb.ca)
 * @version $Id: World.java,v 1.5 2006/11/17 06:23:39 jeffnik Exp $
 */
public class World extends EasyIconTreeNode {
    
    /**
     * The constructor for the World class.
     */
        public World() {
            super();
            // Generate a unique WorldID for this instance
            worldID = System.currentTimeMillis();
            if (DEBUG) {
                System.err.println(java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("World.World():_New_worldID_set_to_") + worldID);
            }
            
            // ImageIcon leafIcon = new ImageIcon(AddEditWorld.class.getResource("icons/22/import.png"));
            
            // setIcon(leafIcon);
            
        }
        
    /**
     * 
     * @param newName 
     */
        public void setWorldName(final String newName) {
            worldName = newName;
        }
        
    /**
     * 
     * @return 
     */
        public String getWorldName() {
            return worldName;
        }
        
    /**
     * 
     * @param addy 
     */
        public void setAddress(final String addy) {
            worldAddress = addy;
        }
        
    /**
     * 
     * @return 
     */
        public String getAddress() {
            return worldAddress;
        }
        
    /**
     * 
     * @param port 
     */
        public void setPort(final int port) {
            worldPort = port;
        }
        
    /**
     * 
     * @return 
     */
        public int getPort() {
            return worldPort;
        }
        
        /**
     * Returns an ID unique to this world.  The ID is generated by
     * this class upon creation of a new world, and cannot be altered.
     * This should help avoid "book-keeping" headaches.
     * @return 
     */
        public long getWorldID() {
            return worldID;
        }
        
        /**
     * This method should only be used if setting up a previously existing
     * world.  Otherwise a unique WorldID is set during the creation of a
     * World object.
     * @param newID 
     */
        public void setWorldID(final long newID) {
            if (DEBUG) {
                System.err.println(java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("World.setWorldID:_updating_ID_to_") + newID);
            }
            
            worldID = newID;
        }
        
    /**
     * 
     * @param state 
     */
        public void setSSL(final boolean state) {
            worldSSL = state;
        }
        
    /**
     * 
     * @return 
     */
        public boolean getSSL() {
            return worldSSL;
        }
        
    /**
     * 
     * @param state 
     */
        public void useAutoLogin(final boolean state) {
            worldAutoLogin = state;
        }
        
    /**
     * 
     * @return 
     */
        public boolean isAutoLogin() {
            return worldAutoLogin;
        }
        
    /**
     * 
     * @param style 
     */
        public void setLoginStyle(final int style) {
            worldLoginStyle = style;
        }
        
    /**
     * 
     * @return 
     */
        public int getLoginStyle() {
            return worldLoginStyle;
        }
        
    /**
     * 
     * @param notes 
     */
        public void setNotes(final String notes) {
            worldNotes = notes;
        }
        
    /**
     * 
     * @return 
     */
        public String getNotes() {
            return worldNotes;
        }
        
    /**
     * 
     * @return 
     */
        public Icon getIcon() {
            final Icon retIcon = new ImageIcon(AddEditWorld.class.getResource(java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("icons/22/browser.png")));
            
            return retIcon;
        }
        
        /**
     * Return a string listing the name, address, and port
     * @return 
     */
        public String toString() {
            final StringBuffer retBuff = new StringBuffer();
            retBuff.append(this.getWorldName());
            retBuff.append(java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("_("));
            retBuff.append(this.getAddress());
            retBuff.append(':');
            retBuff.append(this.getPort());
            retBuff.append(')');
            
            return retBuff.toString();
        }
        
        private String worldName = java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("");
        private String worldAddress = java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("");
        private int worldPort = 0;
        private long worldID;
        private boolean worldSSL;
        private boolean worldAutoLogin;
        private int worldLoginStyle;
        private String worldNotes = java.util.ResourceBundle.getBundle("anecho/JamochaMUD/JamochaMUDBundle").getString("");
        private static final boolean DEBUG = false;
}
